summaryrefslogtreecommitdiffstats
path: root/source/ap/libx86
diff options
context:
space:
mode:
Diffstat (limited to 'source/ap/libx86')
-rwxr-xr-xsource/ap/libx86/libx86.SlackBuild78
-rw-r--r--source/ap/libx86/libx86.info2
-rw-r--r--source/ap/libx86/lrmi.c.diff18
-rw-r--r--source/ap/libx86/slack-desc19
4 files changed, 117 insertions, 0 deletions
diff --git a/source/ap/libx86/libx86.SlackBuild b/source/ap/libx86/libx86.SlackBuild
new file mode 100755
index 000000000..02c54a098
--- /dev/null
+++ b/source/ap/libx86/libx86.SlackBuild
@@ -0,0 +1,78 @@
+#!/bin/sh
+
+# Slackware build script for libx86
+
+# Copyright 2008 Robby Workman, Northport, Alabama, USA
+# Copyright 2008, 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+VERSION=${VERSION:-1.1}
+ARCH=${ARCH:-x86_64}
+BUILD=${BUILD:-1}
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-libx86
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf libx86-$VERSION
+tar xvf $CWD/libx86-$VERSION.tar.gz
+cd libx86-$VERSION || exit 1
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Add a patch from Gentoo to make this build on 2.6.26+
+zcat $CWD/lrmi.c.diff.gz | patch -p1 || exit 1
+
+make BACKEND=x86emu LIBDIR=/usr/lib${LIBDIRSUFFIX} || exit 1
+make install DESTDIR=$PKG LIBDIR=/usr/lib${LIBDIRSUFFIX}
+
+# Kill the static library; we shouldn't need it
+rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libx86.a
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" \
+ | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+mkdir -p $PKG/usr/doc/libx86-$VERSION
+cp -a COPYRIGHT $PKG/usr/doc/libx86-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/libx86-$VERSION-$ARCH-$BUILD.txz
+
diff --git a/source/ap/libx86/libx86.info b/source/ap/libx86/libx86.info
new file mode 100644
index 000000000..1b9bef5c2
--- /dev/null
+++ b/source/ap/libx86/libx86.info
@@ -0,0 +1,2 @@
+HOMEPAGE="http://www.codon.org.uk/~mjg59/libx86/"
+DOWNLOAD="http://www.codon.org.uk/~mjg59/libx86/downloads/libx86-1.1.tar.gz"
diff --git a/source/ap/libx86/lrmi.c.diff b/source/ap/libx86/lrmi.c.diff
new file mode 100644
index 000000000..24f4510ff
--- /dev/null
+++ b/source/ap/libx86/lrmi.c.diff
@@ -0,0 +1,18 @@
+# Patch from Gentoo: http://bugs.gentoo.org/235599
+
+--- old/lrmi.c 2006-10-30 21:10:16.000000000 +0100
++++ new/lrmi.c 2008-08-27 11:32:40.000000000 +0200
+@@ -64,6 +64,13 @@
+ #define DEFAULT_STACK_SIZE 0x1000
+ #define RETURN_TO_32_INT 255
+
++#ifndef IF_MASK
++#define IF_MASK X86_EFLAGS_VIF
++#define IOPL_MASK X86_EFLAGS_IOPL
++#define VIF_MASK X86_EFLAGS_VIF
++#define TF_MASK X86_EFLAGS_TF
++#endif
++
+ #if defined(__linux__)
+ #define CONTEXT_REGS context.vm.regs
+ #define REG(x)
diff --git a/source/ap/libx86/slack-desc b/source/ap/libx86/slack-desc
new file mode 100644
index 000000000..b1e743932
--- /dev/null
+++ b/source/ap/libx86/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler--------------------------------------------------|
+libx86: libx86 (hardware-independent library for x86 code execution)
+libx86:
+libx86: libx86 is a hardware-independent library for executing
+libx86: real-mode x86 code, such as bios calls, from userspace.
+libx86:
+libx86: Homepage: http://www.codon.org.uk/~mjg59/libx86/
+libx86:
+libx86:
+libx86:
+libx86:
+libx86: